<template>
    <div>
        <NavLinks :links="links" :current="textContent.nav.card" />
        <br />
        <p v-if="!isExist">У вас пока нет анкеты!</p>
        <router-link
            v-if="!loading && !questData.is_approved"
            :to="updateLink"
            >{{
                isExist
                    ? textContent.nav.card_update
                    : textContent.nav.card_create
            }}</router-link
        >
        <br /><br />
        <div v-if="isExist">
            <QuestImg :src="documents.passport_first_page.url" />
            <QuestImg :src="documents.passport_second_page.url" />

            <ViewField title="Имя" :name="questData.first_name" />
            <ViewField
                title="Серия паспорта"
                :name="questData.passport_series"
            />
            <ViewField title="Отец" bool :name="questData.father" />
            <ViewField title="Дети" :name="questData.children" />
            <ViewField title="Факультет" :named-data="questData.faculty" />

            <ViewField title="Страна" :name="questData.country" />
            <ViewField
                title="Город (Село, Посёлок)"
                :name="questData.locality"
            />
            <ViewField title="Район" :name="questData.district" />
            <ViewField title="Улица" :name="questData.street" />
            <ViewField title="Дом" :name="questData.house" />

            <ViewField
                title="Специальность"
                :named-data="questData.speciality"
            />
            <ViewField
                title="Форма обучения"
                :named-data="questData.speciality_forma"
            />
            <ViewField
                title="Обучение на основе"
                :named-data="questData.speciality_basis"
            />
            <ViewField
                title="Язык обучения"
                :named-data="questData.speciality_language"
            />
            <QuestBtn
                @click="switchPush"
                v-if="$gates.hasPermission(permissions.APPROVE_QUESTS)"
            >
                {{
                    questData.is_approved
                        ? "Отменить одобрение"
                        : "Одобрить Анкету"
                }}
            </QuestBtn>
            <br />
            <template
                v-if="
                    $gates.hasPermission(permissions.PUSH_QUESTS) &&
                    currentQuest.is_approved
                "
            >
                <QuestBtn @click="pushQuest">Конечные данные</QuestBtn>
                <div v-for="{ key, value } in pushedDataView" :key="key">
                    {{ key }} : {{ value }}
                </div>
            </template>
        </div>
    </div>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
import { initialQuest } from "@/utils/quests";
import ViewField from "@/components/Quests/ViewField";
import QuestImg from "@/components/QuestImg";
import { permissions } from "@/utils/gates";
import { prepDocuments } from "@/utils/documents";
import NavLinks from "@/components/NavLinks";
import { textContent } from "@/utils/textContent";
import questsApi from "@/api/questsApi";
import QuestBtn from "@/components/QuestBtn";
import snackbar from "@/utils/snackbar";

export default {
    name: "QuestView",
    components: { QuestBtn, NavLinks, QuestImg, ViewField },
    props: { isAdmin: Boolean },
    data: () => ({
        loading: true,
        permissions,
        textContent,
        pushedDataView: null,
    }),
    methods: {
        ...mapActions("quests", [
            "getMyQuest",
            "getQuest",
            "approveQuest",
            "cancelApproveQuest",
        ]),
        async pushQuest() {
            const json = await questsApi.pushQuest(this.currentQuest.id);
            this.pushedDataView = Object.entries(json).map(([key, value]) => ({
                key,
                value,
            }));
        },
        async getData() {
            try {
                this.loading = true;
                !this.isAdmin
                    ? await this.getMyQuest()
                    : await this.getQuest(this.$route.params.id);
            } catch (e) {
                snackbar(e);
            } finally {
                this.loading = false;
            }
        },
        async switchPush() {
            try {
                await (this.questData.is_approved
                    ? this.cancelApproveQuest(this.questData.id)
                    : this.approveQuest(this.questData.id));
            } catch (e) {
                snackbar(e);
            }
        },
    },
    computed: {
        ...mapState("quests", ["currentQuest"]),
        ...mapGetters("quests", ["isExist"]),
        questData() {
            return this.currentQuest || { ...initialQuest };
        },
        updateLink() {
            return this.isAdmin
                ? {
                      name: "AdminQuestUpdate",
                      params: { id: this.$route.params.id },
                  }
                : { name: "QuestUpdate" };
        },
        documents() {
            return prepDocuments(this.questData);
        },
        links() {
            const welcomeLink = {
                text: textContent.nav.general,
                to: { name: "Welcome" },
            };

            const listLink = {
                text: textContent.nav.card_list,
                to: { name: "QuestList" },
            };
            return this.isAdmin ? [welcomeLink, listLink] : [welcomeLink];
        },
    },
    mounted() {
        this.getData();
    },
};
</script>

<style scoped></style>
